﻿using System;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Controls;

namespace WpfApp1
{
    public class MyCustomBlock : Canvas
    {
        public MyCustomBlock() => Text = "<default>";
        public MyCustomBlock(string text) => Text = text;

        private static void TextChangedCallback(DependencyObject o,
                                                DependencyPropertyChangedEventArgs e)
        {
            Console.WriteLine("New Text {0}", e.NewValue);
        }

        public string Text
        {
            get => (string)GetValue(TextProperty);
            set => SetValue(TextProperty, value);
        }

        public static readonly DependencyProperty TextProperty =
            DependencyProperty.Register(
                  nameof(Text), typeof(string), typeof(MyCustomBlock),
                  new FrameworkPropertyMetadata("", TextChangedCallback));
    }

    public class MyCustomItem
    {
        public MyCustomItem(string text) => ItemText = text;
        public string ItemText { get; set; }
    }

    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var list = new ObservableCollection<MyCustomItem>();
            list.Add(new MyCustomItem("Hello"));
            list.Add(new MyCustomItem("World"));
            MyCustomItemList.ItemsSource = list;
        }
    }
}
